﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace Mapy {
    public partial class Form1 : Form {
        public Form1 () {
            InitializeComponent ();
            MessageBox.Show ("Myší prosím pohybujte pomalu. Děkuji.", "Upozornění", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            MessageBox.Show ("Pohybovat s mapou lze tahem myši, přibližovat dvojklikem!", "Nápověda", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        int zoom = 0;
        int x = 1;
        int y = 1;
        System.Drawing.Image img;
        int xnew;
        int ynew;
        string port = "";

        int littleposx;
        int littleposy;

        bool isdown;

        #region zakladni

        private void panel1_Paint (object sender, PaintEventArgs e) {
            Graphics g = e.Graphics;
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighSpeed;
            g.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighSpeed;
            g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;
            g.CompositingQuality = System.Drawing.Drawing2D.CompositingQuality.HighSpeed;
            for (int j = -2; j < 3; j++) {
                for (int i = -2; i < 3; i++) {
                    int posx = i;
                    int posy = j;
                    xnew = x + posx;
                    ynew = y + posy;
                    if ((ynew < 0) || (ynew >= (2 * Math.Pow ((double)2, (double)zoom))) || (xnew < 0) || (xnew >= (3 * Math.Pow ((double)2, (double)zoom)))) { } else {
                        getimage (xnew, ynew);
                        g.DrawImage (img, (i + 1) * 256 + 256, (j + 1) * 256 + 256, 256, 256);
                    }
                }
            }

        }

        private void Form1_SizeChanged (object sender, EventArgs e) {
            panel1.Invalidate ();
        }

        private void getimage (int xnew, int ynew) {
            WebClient wc = new WebClient ();
            byte[] bytes = wc.DownloadData ("http://192.168.2.76" + port + "/" + zoom + "/" + xnew + "/" + ynew + ".jpg");
            MemoryStream ms = new MemoryStream (bytes);
            img = System.Drawing.Image.FromStream (ms);
        }

        private void button1_Click (object sender, EventArgs e) {

        }

        private void Form1_Load (object sender, EventArgs e) {

        }

        private void numericUpDown3_ValueChanged (object sender, EventArgs e) {
            if (numericUpDown3.Value > zoom) {
                numericUpDown1.Value = (numericUpDown1.Value) * 2;
                numericUpDown2.Value = (numericUpDown2.Value) * 2;
            } else {
                numericUpDown1.Value = (numericUpDown1.Value) / 2;
                numericUpDown2.Value = (numericUpDown2.Value) / 2;
            }

            x = (int)numericUpDown1.Value;
            y = (int)numericUpDown2.Value;

            zoom = (int)numericUpDown3.Value;

            littleposx = 0;
            littleposy = 0;
            //numericUpDown1.Maximum = 3 * (int)(Math.Pow ((double)2, (double)zoom));
            //numericUpDown2.Maximum = 2 * (int)(Math.Pow ((double)2, (double)zoom));
            panel1.Invalidate ();
        }

        private void numericUpDown1_ValueChanged (object sender, EventArgs e) {
            x = (int)numericUpDown1.Value;
            panel1.Invalidate ();
        }

        private void numericUpDown2_ValueChanged (object sender, EventArgs e) {
            y = (int)numericUpDown2.Value;
            panel1.Invalidate ();
        }

        #endregion

        #region zobrazovani

        Point bod = new Point ();

        private void panel1_MouseUp (object sender, MouseEventArgs e) {
            isdown = false;
        }

        private void panel1_MouseMove (object sender, MouseEventArgs e) {
            if (isdown) {
                littleposx += e.Location.X - bod.X;
                littleposy += e.Location.Y - bod.Y;
                bod = e.Location;

                if ((littleposx <= -256) && (numericUpDown1.Value < 1536)) {
                    numericUpDown1.Value++;
                    littleposx = 0;
                } else if ((littleposx >= 256) && (numericUpDown1.Value > 0)) {
                    numericUpDown1.Value--;
                    littleposx = 0;
                }

                if ((littleposy <= -256) && (numericUpDown2.Value < 1024)) {
                    numericUpDown2.Value++;
                    littleposy = 0;
                } else if ((littleposy >= 256) && (numericUpDown2.Value > 0)) {
                    numericUpDown2.Value--;
                    littleposy = 0;
                }


                panel1.Location = new Point (littleposx - 256, littleposy - 256);
            }
        }

        private void panel1_MouseDown (object sender, MouseEventArgs e) {
            isdown = true;
            bod = e.Location;
        }

        #endregion

        private void panel1_LocationChanged (object sender, EventArgs e) {
        }

        private void panel1_MouseDoubleClick (object sender, MouseEventArgs e) {
            if (numericUpDown3.Value < 9) {
                numericUpDown3.Value++;
            }
        }

        private void timer1_Tick (object sender, EventArgs e) {

        }
    }
}
